Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.sql
Interface Driver

public interface Driver

The interface that every driver class must implement.

The Java SQL framework allows for multiple database drivers.

Each driver should supply a class that implements the Driver interface.

The DriverManager will try to load as many drivers as it can find and then for any given connection request, it will ask each driver in turn to try to connect to the target URL.

It is strongly recommended that each Driver class should be small and standalone so that the Driver class can be loaded and queried without bringing in vast quantities of supporting code.

When a Driver class is loaded, it should create an instance of itself and register it with the DriverManager. This means that a user can load and register a driver by calling

       Class.forName("foo.bah.Driver")

See Also:
  `DriverManager`, `Connection`

Method Summary
`boolean` | `acceptsURL(String url)` Returns true if the driver thinks that it can open a connection to the given URL.
`Connection` | `connect(String url, Properties info)` Attempts to make a database connection to the given URL.
`int` | `getMajorVersion()` Gets the driver's major version number.
`int` | `getMinorVersion()` Gets the driver's minor version number.
`DriverPropertyInfo[]` | `getPropertyInfo(String url, Properties info)` Gets information about the possible properties for this driver.
`boolean` | `jdbcCompliant()` Reports whether this driver is a genuine JDBC COMPLIANTTM driver.

Method Detail

### connect

    public Connection connect(String url,
                              Properties info)
                       throws SQLException

  Attempts to make a database connection to the given URL. The driver should return "null" if it realizes it is the wrong kind of driver to connect to the given URL. This will be common, as when the JDBC driver manager is asked to connect to a given URL it passes the URL to each loaded driver in turn.

  The driver should raise a SQLException if it is the right driver to connect to the given URL, but has trouble connecting to the database.

  The java.util.Properties argument can be used to passed arbitrary string tag/value pairs as connection arguments. Normally at least "user" and "password" properties should be included in the Properties.

  Parameters:
    `url` - the URL of the database to which to connect
    `info` - a list of arbitrary string tag/value pairs as connection arguments. Normally at least a "user" and "password" property should be included.
  Returns:
    a `Connection` object that represents a connection to the URL
  Throws:
    `SQLException` - if a database access error occurs

### acceptsURL

    public boolean acceptsURL(String url)
                       throws SQLException

  Returns true if the driver thinks that it can open a connection to the given URL. Typically drivers will return true if they understand the subprotocol specified in the URL and false if they don't.
  Parameters:
    `url` - the URL of the database
  Returns:
    true if this driver can connect to the given URL
  Throws:
    `SQLException` - if a database access error occurs

### getPropertyInfo

    public DriverPropertyInfo[] getPropertyInfo(String url,
                                                Properties info)
                                         throws SQLException

  Gets information about the possible properties for this driver.

  The getPropertyInfo method is intended to allow a generic GUI tool to discover what properties it should prompt a human for in order to get enough information to connect to a database. Note that depending on the values the human has supplied so far, additional values may become necessary, so it may be necessary to iterate though several calls to getPropertyInfo.

  Parameters:
    `url` - the URL of the database to which to connect
    `info` - a proposed list of tag/value pairs that will be sent on connect open
  Returns:
    an array of DriverPropertyInfo objects describing possible properties. This array may be an empty array if no properties are required.
  Throws:
    `SQLException` - if a database access error occurs

### getMajorVersion

    public int getMajorVersion()

  Gets the driver's major version number. Initially this should be 1.
  Returns:
    this driver's major version number

### getMinorVersion

    public int getMinorVersion()

  Gets the driver's minor version number. Initially this should be 0.
  Returns:
    this driver's minor version number

### jdbcCompliant

    public boolean jdbcCompliant()

  Reports whether this driver is a genuine JDBC COMPLIANTTM driver. A driver may only report true here if it passes the JDBC compliance tests; otherwise it is required to return false. JDBC compliance requires full support for the JDBC API and full support for SQL 92 Entry Level. It is expected that JDBC compliant drivers will be available for all the major commercial databases. This method is not intended to encourage the development of non-JDBC compliant drivers, but is a recognition of the fact that some vendors are interested in using the JDBC API and framework for lightweight databases that do not support full database functionality, or for special databases such as document information retrieval where a SQL implementation may not be feasible.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.